<?php
  ///////////////////////////////////////////////////
  // Система учёта посещаемости сайта - PowerCounter
  // 2003-2006 (C) IT-студия SoftTime (http://www.softtime.ru)
  // Поддержка: http://www.softtime.ru/forum/
  // Симдянов И.В. (simdyanov@softtime.ru)
  // Левин А.В. (loki_angel@mail.ru)
  // Кузнецов М.В. (kuznetsov@softtime.ru)
  // Голышев С.В. (softtime@softtime.ru)
  ///////////////////////////////////////////////////
  // Выставляем уровень обработки ошибок (http://www.softtime.ru/info/articlephp.php?id_article=23)
  Error_Reporting(E_ALL & ~E_NOTICE); 

// Функция архивации клиентов в суточные таблицы
function archive_client($tbl_ip, $tbl_arch_clients)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data FROM $tbl_ip");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);
  //Последнее полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate)) FROM $tbl_arch_clients";
  $arh = mysql_query($query);
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_ip 
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }
  //блок архивации
  if (ceil(($last_day - $last_date)/24/60/60))
  {
    $days = ceil(($last_day-$last_date)/24/60/60);
    for ($i = $days; $i>0; $i--)
    {
      // Вспомогательное условие                //изменено 26.02.06 Loki
      $tmp = "systems NOT LIKE 'robot_%' AND 
                  putdate < '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY AND
              putdate >= '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL $i DAY";

      $query_browsers_msie     = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE browsers = 'msie' AND ".$tmp;
      $query_browsers_opera    = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE browsers = 'opera' AND ".$tmp;
      $query_browsers_netscape = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE browsers = 'netscape' AND ".$tmp;
      $query_browsers_firefox  = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE browsers = 'firefox' AND ".$tmp;
      $query_browsers_myie     = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE browsers = 'myie' AND ".$tmp;
      $query_browsers_mozilla  = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE browsers = 'mozilla' AND ".$tmp;
      $query_browsers_none     = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE browsers = 'none' AND ".$tmp;

      $query_systems_windows   = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE systems = 'windows' AND ".$tmp;
      $query_systems_unix      = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE systems = 'unix' AND ".$tmp;
      $query_systems_macintosh = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE systems = 'macintosh' AND ".$tmp;
      $query_systems_none      = "SELECT COUNT(DISTINCT ip) FROM $tbl_ip WHERE systems = 'none' AND ".$tmp;

      $bms = mysql_query($query_browsers_msie);
      if(!$bms) exit(mysql_error());
      $bop = mysql_query($query_browsers_opera);
      if(!$bop) exit(mysql_error());
      $bnt = mysql_query($query_browsers_netscape);
      if(!$bnt) exit(mysql_error());
      $ffx = mysql_query($query_browsers_firefox);
      if(!$ffx) exit(mysql_error());
      $mie = mysql_query($query_browsers_myie);
      if(!$mie) exit(mysql_error());
      $moz = mysql_query($query_browsers_mozilla);
      if(!$moz) exit(mysql_error());
      $bnn = mysql_query($query_browsers_none);
      if(!$bnn) exit(mysql_error());

      $swn = mysql_query($query_systems_windows);
      if(!$swn) exit(mysql_error());
      $unx = mysql_query($query_systems_unix);
      if(!$unx) exit(mysql_error());
      $mac = mysql_query($query_systems_macintosh);
      if(!$mac) exit(mysql_error());
      $snn = mysql_query($query_systems_none);
      if(!$snn) exit(mysql_error());

      // Формируем запрос для ахивации хитов и хостов в таблицу $tbl_arch_client
      $browsers_msie     = mysql_result($bms, 0);
      $browsers_opera    = mysql_result($bop, 0);
      $browsers_netscape = mysql_result($bnt, 0);
      $browsers_firefox  = mysql_result($ffx, 0);
      $browsers_myie     = mysql_result($mie, 0);
      $browsers_mozilla  = mysql_result($moz, 0);
      $browsers_none     = mysql_result($bnn, 0);

      $systems_windows   = mysql_result($swn, 0);
      $systems_unix      = mysql_result($unx, 0);
      $systems_macintosh = mysql_result($mac, 0);
      $systems_none      = mysql_result($snn, 0);

      $sql_clients[] = "(NULL,
                        '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY,
                        $browsers_msie,
                        $browsers_opera,
                        $browsers_netscape,
                        $browsers_firefox,
                        $browsers_myie,
                        $browsers_mozilla,
                        $browsers_none,
                        $systems_windows,
                        $systems_unix,
                        $systems_macintosh,
                        $systems_none)";
    }
    if(!empty($sql_clients))
    {
      $query = "INSERT INTO $tbl_arch_clients VALUES".implode(",", $sql_clients);
      if(!mysql_query($query)) exit("ip1".mysql_error());
    }
  }
}


// Функция архивации браузеров и операционных систем в недельные таблицы
function archive_client_week($tbl_arch_clients, $tbl_arch_clients_week)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data FROM $tbl_arch_clients");
  if (!$dat) exit("date_week_client1 ".mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate_end)) FROM $tbl_arch_clients_week";
  $arh = mysql_query($query);
  if(!$arh) exit("date_week_client2 ".mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_ip 
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // Вычисляем сколько недель прошло с даты последней архивации
  $week = floor(($last_day - $last_date)/24/60/60/7); 

  // Если прошло больше недели - архивируем данные
  if ($week > 0)
  {
    // $last_date - дата последней архивации... - смотрим далеко ли до
    // конца недели (воскресенье). Интервал включает данные с Понедельника (1)
    // до воскресенья (0).
    $weekday = date('w',$last_date);
    // Делаем так, чтобы воскресенье было 7, а понедельник 1
    // if($weekday === 0) $weekday = 7;

    // Текущему времени приравниваем начальную точку
    $current_date = $last_date;
    while(floor(($last_day - $current_date)/24/60/60/7))
    {
      // Вспомогательное условие
      $tmp = "putdate > '".date("Y-m-d 23:59:59", $current_date)."' AND
              putdate <= '" .date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."'";

      $query_browsers_msie     = "SELECT SUM(browsers_msie)     FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_opera    = "SELECT SUM(browsers_opera)    FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_netscape = "SELECT SUM(browsers_netscape) FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_firefox  = "SELECT SUM(browsers_firefox)  FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_myie     = "SELECT SUM(browsers_myie)     FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_mozilla  = "SELECT SUM(browsers_mozilla)  FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_none     = "SELECT SUM(browsers_none)     FROM $tbl_arch_clients WHERE ".$tmp;

      $query_systems_windows   = "SELECT SUM(systems_windows)   FROM $tbl_arch_clients WHERE ".$tmp;
      $query_systems_unix      = "SELECT SUM(systems_unix)      FROM $tbl_arch_clients WHERE ".$tmp;
      $query_systems_macintosh = "SELECT SUM(systems_macintosh) FROM $tbl_arch_clients WHERE ".$tmp;
      $query_systems_none      = "SELECT SUM(systems_none)      FROM $tbl_arch_clients WHERE ".$tmp;

      $bms = mysql_query($query_browsers_msie);
      if(!$bms) exit("IE_clients_week ".mysql_error());
      $bop = mysql_query($query_browsers_opera);
      if(!$bop) exit(mysql_error());
      $bnt = mysql_query($query_browsers_netscape);
      if(!$bnt) exit(mysql_error());
      $ffx = mysql_query($query_browsers_firefox);
      if(!$ffx) exit(mysql_error());
      $mie = mysql_query($query_browsers_myie);
      if(!$mie) exit(mysql_error());
      $moz = mysql_query($query_browsers_mozilla);
      if(!$moz) exit(mysql_error());
      $bnn = mysql_query($query_browsers_none);
      if(!$bnn) exit(mysql_error());

      $swn = mysql_query($query_systems_windows);
      if(!$swn) exit(mysql_error());
      $unx = mysql_query($query_systems_unix);
      if(!$unx) exit(mysql_error());
      $mac = mysql_query($query_systems_macintosh);
      if(!$mac) exit(mysql_error());
      $snn = mysql_query($query_systems_none);
      if(!$snn) exit(mysql_error());

      // Формируем запрос для ахивации хитов и хостов в таблицу $tbl_arch_client
      $browsers_msie     = mysql_result($bms, 0);
      $browsers_opera    = mysql_result($bop, 0);
      $browsers_netscape = mysql_result($bnt, 0);
      $browsers_firefox  = mysql_result($ffx, 0);
      $browsers_myie     = mysql_result($mie, 0);
      $browsers_mozilla  = mysql_result($moz, 0);
      $browsers_none     = mysql_result($bnn, 0);
      $systems_windows   = mysql_result($swn, 0);
      $systems_unix      = mysql_result($unx, 0);
      $systems_macintosh = mysql_result($mac, 0);
      $systems_none      = mysql_result($snn, 0);
      $sql_clients[] = "(NULL,
                        '".date("Y-m-d 23:59:59", $current_date)."',
                        '".date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."', 
                        $browsers_msie,
                        $browsers_opera,
                        $browsers_netscape,
                        $browsers_firefox,
                        $browsers_myie,
                        $browsers_mozilla,
                        $browsers_none,
                        $systems_windows,
                        $systems_unix,
                        $systems_macintosh,
                        $systems_none)";

      // Увеличиваем текущее время до следующей недели
      $current_date += (7 - $weekday)*24*3600;
      $weekday = 0; // Далее идут циклы по целой недели
      // echo date("Y-m-d 23:59:59", $current_date)."<br>";
    }
    if(!empty($sql_clients))
    {
      $query = "INSERT INTO $tbl_arch_clients_week VALUES".implode(",", $sql_clients);
      if(!mysql_query($query)) exit($query.mysql_error());
    }
  }
}


// Функция архивации браузеров и операционных систем в месячные таблицы
function archive_clients_month($tbl_arch_clients, $tbl_arch_clients_month)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_clients");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate + INTERVAL 1 MONTH)) 
            FROM $tbl_arch_clients_month";
  $arh = mysql_query($query);
  if(!$arh) exit(mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_clients
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y")) + 2;
  // Вычисляем сколько полных месяцев прошло с даты последней архивации
  $month = (floor(date("Y",$last_day) - date("Y",$last_date)))*12 + 
           floor(date("m",$last_day) - date("m",$last_date)); 

  // Если прошло больше месяца - архивируем данные
  if ($month > 0)
  {
    // Архивируем данные по всем месяцам, по которым архивация
    // не проводилась
    for($i = date("Y",$last_date)*12 + date("m",$last_date); $i < date("Y",$last_day)*12 + date("m",$last_day); $i++)
    {
      $year = (int)($i/12);
      $month = ($i%12);
      if($month == 0)
      {
        $year--;
        $month = 12;
      }
      // Вспомогательное условие
      $tmp = "YEAR(putdate) = $year AND
              MONTH(putdate) = '".sprintf("%02d",$month)."'";

      $query_browsers_msie     = "SELECT SUM(browsers_msie)     FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_opera    = "SELECT SUM(browsers_opera)    FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_netscape = "SELECT SUM(browsers_netscape) FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_firefox  = "SELECT SUM(browsers_firefox)  FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_myie     = "SELECT SUM(browsers_myie)     FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_mozilla  = "SELECT SUM(browsers_mozilla)  FROM $tbl_arch_clients WHERE ".$tmp;
      $query_browsers_none     = "SELECT SUM(browsers_none)     FROM $tbl_arch_clients WHERE ".$tmp;

      $query_systems_windows   = "SELECT SUM(systems_windows)   FROM $tbl_arch_clients WHERE ".$tmp;
      $query_systems_unix      = "SELECT SUM(systems_unix)      FROM $tbl_arch_clients WHERE ".$tmp;
      $query_systems_macintosh = "SELECT SUM(systems_macintosh) FROM $tbl_arch_clients WHERE ".$tmp;
      $query_systems_none      = "SELECT SUM(systems_none)      FROM $tbl_arch_clients WHERE ".$tmp;

      $bms = mysql_query($query_browsers_msie);
      if(!$bms) exit(mysql_error());
      $bop = mysql_query($query_browsers_opera);
      if(!$bop) exit(mysql_error());
      $bnt = mysql_query($query_browsers_netscape);
      if(!$bnt) exit(mysql_error());
      $ffx = mysql_query($query_browsers_firefox);
      if(!$ffx) exit(mysql_error());
      $mie = mysql_query($query_browsers_myie);
      if(!$mie) exit(mysql_error());
      $moz = mysql_query($query_browsers_mozilla);
      if(!$moz) exit(mysql_error());
      $bnn = mysql_query($query_browsers_none);
      if(!$bnn) exit(mysql_error());

      $swn = mysql_query($query_systems_windows);
      if(!$swn) exit(mysql_error());
      $unx = mysql_query($query_systems_unix);
      if(!$unx) exit(mysql_error());
      $mac = mysql_query($query_systems_macintosh);
      if(!$mac) exit(mysql_error());
      $snn = mysql_query($query_systems_none);
      if(!$snn) exit(mysql_error());

      // Формируем запрос для ахивации хитов и хостов в таблицу $tbl_arch_client_week
      $browsers_msie     = mysql_result($bms, 0);
      $browsers_opera    = mysql_result($bop, 0);
      $browsers_netscape = mysql_result($bnt, 0);
      $browsers_firefox  = mysql_result($ffx, 0);
      $browsers_myie     = mysql_result($mie, 0);
      $browsers_mozilla  = mysql_result($moz, 0);
      $browsers_none     = mysql_result($bnn, 0);
      $systems_windows   = mysql_result($swn, 0);
      $systems_unix      = mysql_result($unx, 0);
      $systems_macintosh = mysql_result($mac, 0);
      $systems_none      = mysql_result($snn, 0);
      $sql_clients[] = "(NULL,
                       '$year-".sprintf("%02d",$month)."-01 23:59:59',
                        $browsers_msie,
                        $browsers_opera,
                        $browsers_netscape,
                        $browsers_firefox,
                        $browsers_myie,
                        $browsers_mozilla,
                        $browsers_none,
                        $systems_windows,
                        $systems_unix,
                        $systems_macintosh,
                        $systems_none)";
    }

    if(!empty($sql_clients))
    {
      $query = "INSERT INTO $tbl_arch_clients_month VALUES".implode(",", $sql_clients);
      if(!mysql_query($query)) exit($query.mysql_error());
    }
  }
}
?>
